diff --git a/modules/nrfx/drivers/include/nrfx_gpiote.h b/modules/nrfx/drivers/include/nrfx_gpiote.h
index 34d1b4d..2bbeaf3 100644
--- a/modules/nrfx/drivers/include/nrfx_gpiote.h
+++ b/modules/nrfx/drivers/include/nrfx_gpiote.h
@@ -70,30 +70,30 @@ typedef struct
  * @details Set hi_accu to true to use IN_EVENT. */
 #define NRFX_GPIOTE_CONFIG_IN_SENSE_LOTOHI(hi_accu) \
     {                                               \
+        .sense = NRF_GPIOTE_POLARITY_LOTOHI,        \
+        .pull = NRF_GPIO_PIN_NOPULL,                \
         .is_watcher = false,                        \
         .hi_accuracy = hi_accu,                     \
-        .pull = NRF_GPIO_PIN_NOPULL,                \
-        .sense = NRF_GPIOTE_POLARITY_LOTOHI,        \
     }
 
 /**@brief Macro for configuring a pin to use a GPIO IN or PORT EVENT to detect high-to-low transition.
  * @details Set hi_accu to true to use IN_EVENT. */
 #define NRFX_GPIOTE_CONFIG_IN_SENSE_HITOLO(hi_accu) \
     {                                               \
+        .sense = NRF_GPIOTE_POLARITY_HITOLO,        \
+        .pull = NRF_GPIO_PIN_NOPULL,                \
         .is_watcher = false,                        \
         .hi_accuracy = hi_accu,                     \
-        .pull = NRF_GPIO_PIN_NOPULL,                \
-        .sense = NRF_GPIOTE_POLARITY_HITOLO,        \
     }
 
 /**@brief Macro for configuring a pin to use a GPIO IN or PORT EVENT to detect any change on the pin.
  * @details Set hi_accu to true to use IN_EVENT.*/
 #define NRFX_GPIOTE_CONFIG_IN_SENSE_TOGGLE(hi_accu) \
     {                                               \
+        .sense = NRF_GPIOTE_POLARITY_TOGGLE,        \
+        .pull = NRF_GPIO_PIN_NOPULL,                \
         .is_watcher = false,                        \
         .hi_accuracy = hi_accu,                     \
-        .pull = NRF_GPIO_PIN_NOPULL,                \
-        .sense = NRF_GPIOTE_POLARITY_TOGGLE,        \
     }
 
 /**@brief Macro for configuring a pin to use a GPIO IN or PORT EVENT to detect low-to-high transition.
@@ -101,10 +101,10 @@ typedef struct
  * @note This macro prepares configuration that skips GPIO setup. */
 #define NRFX_GPIOTE_RAW_CONFIG_IN_SENSE_LOTOHI(hi_accu) \
     {                                               \
+        .sense = NRF_GPIOTE_POLARITY_LOTOHI,        \
+        .pull = NRF_GPIO_PIN_NOPULL,                \
         .is_watcher = false,                        \
         .hi_accuracy = hi_accu,                     \
-        .pull = NRF_GPIO_PIN_NOPULL,                \
-        .sense = NRF_GPIOTE_POLARITY_LOTOHI,        \
         .skip_gpio_setup = true,                    \
     }
 
@@ -113,10 +113,10 @@ typedef struct
  * @note This macro prepares configuration that skips GPIO setup. */
 #define NRFX_GPIOTE_RAW_CONFIG_IN_SENSE_HITOLO(hi_accu) \
     {                                               \
+        .sense = NRF_GPIOTE_POLARITY_HITOLO,        \
+        .pull = NRF_GPIO_PIN_NOPULL,                \
         .is_watcher = false,                        \
         .hi_accuracy = hi_accu,                     \
-        .pull = NRF_GPIO_PIN_NOPULL,                \
-        .sense = NRF_GPIOTE_POLARITY_HITOLO,        \
         .skip_gpio_setup = true,                    \
     }
 
@@ -125,10 +125,10 @@ typedef struct
  * @note This macro prepares configuration that skips GPIO setup. */
 #define NRFX_GPIOTE_RAW_CONFIG_IN_SENSE_TOGGLE(hi_accu) \
     {                                               \
+        .sense = NRF_GPIOTE_POLARITY_TOGGLE,        \
+        .pull = NRF_GPIO_PIN_NOPULL,                \
         .is_watcher = false,                        \
         .hi_accuracy = hi_accu,                     \
-        .pull = NRF_GPIO_PIN_NOPULL,                \
-        .sense = NRF_GPIOTE_POLARITY_TOGGLE,        \
         .skip_gpio_setup = true,                    \
     }
 
@@ -144,35 +144,36 @@ typedef struct
 /**@brief Macro for configuring a pin to use as output. GPIOTE is not used for the pin. */
 #define NRFX_GPIOTE_CONFIG_OUT_SIMPLE(init_high)                                                \
     {                                                                                           \
+        .action     = (nrf_gpiote_polarity_t) 0,                                                \
         .init_state = init_high ? NRF_GPIOTE_INITIAL_VALUE_HIGH : NRF_GPIOTE_INITIAL_VALUE_LOW, \
-        .task_pin = false,                                                                      \
+        .task_pin   = false,                                                                    \
     }
 
 /**@brief Macro for configuring a pin to use the GPIO OUT TASK to change the state from high to low.
  * @details The task will clear the pin. Therefore, the pin is set initially.  */
 #define NRFX_GPIOTE_CONFIG_OUT_TASK_LOW              \
     {                                                \
+        .action     = NRF_GPIOTE_POLARITY_HITOLO,    \
         .init_state = NRF_GPIOTE_INITIAL_VALUE_HIGH, \
         .task_pin   = true,                          \
-        .action     = NRF_GPIOTE_POLARITY_HITOLO,    \
     }
 
 /**@brief Macro for configuring a pin to use the GPIO OUT TASK to change the state from low to high.
  * @details The task will set the pin. Therefore, the pin is cleared initially.  */
 #define NRFX_GPIOTE_CONFIG_OUT_TASK_HIGH            \
     {                                               \
+        .action     = NRF_GPIOTE_POLARITY_LOTOHI,   \
         .init_state = NRF_GPIOTE_INITIAL_VALUE_LOW, \
         .task_pin   = true,                         \
-        .action     = NRF_GPIOTE_POLARITY_LOTOHI,   \
     }
 
 /**@brief Macro for configuring a pin to use the GPIO OUT TASK to toggle the pin state.
  * @details The initial pin state must be provided.  */
 #define NRFX_GPIOTE_CONFIG_OUT_TASK_TOGGLE(init_high)                                           \
     {                                                                                           \
+        .action     = NRF_GPIOTE_POLARITY_TOGGLE,                                               \
         .init_state = init_high ? NRF_GPIOTE_INITIAL_VALUE_HIGH : NRF_GPIOTE_INITIAL_VALUE_LOW, \
         .task_pin   = true,                                                                     \
-        .action     = NRF_GPIOTE_POLARITY_TOGGLE,                                               \
     }
 
 /** @brief Pin. */