diff --git a/examples/beaconing/beaconing_nrf52832_xxAA_s132_7_0_1.emProject b/examples/beaconing/beaconing_nrf52832_xxAA_s132_7_0_1.emProject
index 991eba1..e723c56 100644
--- a/examples/beaconing/beaconing_nrf52832_xxAA_s132_7_0_1.emProject
+++ b/examples/beaconing/beaconing_nrf52832_xxAA_s132_7_0_1.emProject
@@ -21,6 +21,7 @@
       
       debug_additional_load_file="$(SDK_ROOT:../../../nRF5_SDK_16.0.0_98a08e2)/components/softdevice/s132/hex/s132_nrf52_7.0.1_softdevice.hex"
       
+      debug_register_definition_file="../../../nRF5_SDK/modules/nrfx/mdk/nrf52.svd"
       debug_start_from_entry_point_symbol="No"
       linker_output_format="hex"
       linker_printf_width_precision_supported="Yes"
@@ -182,7 +183,8 @@
                  gcc_optimization_level="Debug"
                  gcc_entry_point="Reset_Handler"
                  build_intermediate_directory="build/$(ProjectName)_$(Configuration)/obj"
-                 build_output_directory="build/$(ProjectName)_$(Configuration)">
+                 build_output_directory="build/$(ProjectName)_$(Configuration)"
+                 c_preprocessor_definitions="DEBUG_PINS_ENABLED=1;CONFIG_NFCT_PINS_AS_GPIOS">
   </configuration>
   <configuration Name="ReleaseWithDebugInformation"
                  arm_use_builtins="Yes"
diff --git a/examples/beaconing/include/sdk_config.h b/examples/beaconing/include/sdk_config.h
index 76d9290..dfae0d6 100644
--- a/examples/beaconing/include/sdk_config.h
+++ b/examples/beaconing/include/sdk_config.h
@@ -5628,7 +5628,7 @@
 // <196609=> External Full Swing
 
 #ifndef CLOCK_CONFIG_LF_SRC
-#define CLOCK_CONFIG_LF_SRC 1
+#define CLOCK_CONFIG_LF_SRC 0
 #endif
 
 // <q> CLOCK_CONFIG_LF_CAL_ENABLED  - Calibration enable for LF Clock Source
@@ -12637,12 +12637,12 @@
 // <2=> NRF_CLOCK_LF_SRC_SYNTH
 
 #ifndef NRF_SDH_CLOCK_LF_SRC
-#define NRF_SDH_CLOCK_LF_SRC 1
+#define NRF_SDH_CLOCK_LF_SRC 0
 #endif
 
 // <o> NRF_SDH_CLOCK_LF_RC_CTIV - SoftDevice calibration timer interval.
 #ifndef NRF_SDH_CLOCK_LF_RC_CTIV
-#define NRF_SDH_CLOCK_LF_RC_CTIV 0
+#define NRF_SDH_CLOCK_LF_RC_CTIV 16
 #endif
 
 // <o> NRF_SDH_CLOCK_LF_RC_TEMP_CTIV - SoftDevice calibration timer interval under constant temperature.
@@ -12650,7 +12650,7 @@
 // <i>  if the temperature has not changed.
 
 #ifndef NRF_SDH_CLOCK_LF_RC_TEMP_CTIV
-#define NRF_SDH_CLOCK_LF_RC_TEMP_CTIV 0
+#define NRF_SDH_CLOCK_LF_RC_TEMP_CTIV 2
 #endif
 
 // <o> NRF_SDH_CLOCK_LF_ACCURACY  - External clock accuracy used in the LL to compute timing.
@@ -12669,7 +12669,7 @@
 // <11=> NRF_CLOCK_LF_ACCURACY_1_PPM
 
 #ifndef NRF_SDH_CLOCK_LF_ACCURACY
-#define NRF_SDH_CLOCK_LF_ACCURACY 7
+#define NRF_SDH_CLOCK_LF_ACCURACY 1
 #endif
 
 // </h>
diff --git a/examples/beaconing/src/main.c b/examples/beaconing/src/main.c
index 0f95305..cf9f09f 100644
--- a/examples/beaconing/src/main.c
+++ b/examples/beaconing/src/main.c
@@ -54,6 +54,8 @@
 #include "example_common.h"
 #include "nrf_mesh_configure.h"
 #include "ad_type_filter.h"
+#include "debug_pins.h"
+#include "timeslot_timer.h"
 
 #if defined(NRF51) && defined(NRF_MESH_STACK_DEPTH)
 #include "stack_depth.h"
@@ -98,57 +100,11 @@ static void rx_cb(const nrf_mesh_adv_packet_rx_data_t * p_rx_data)
     LEDS_ON(BSP_LED_0_MASK);  /* @c LED_RGB_RED_MASK on pca10031 */
 }
 
-static void adv_init(void)
-{
-    advertiser_instance_init(&m_advertiser, NULL, m_adv_buffer, ADVERTISER_BUFFER_SIZE);
-}
-
-static void adv_start(void)
-{
-    /* Let scanner accept Complete Local Name AD Type. */
-    bearer_adtype_add(BLE_GAP_AD_TYPE_COMPLETE_LOCAL_NAME);
-
-    advertiser_enable(&m_advertiser);
-    static const uint8_t adv_data[] =
-    {
-        0x11, /* AD data length (including type, but not itself) */
-        BLE_GAP_AD_TYPE_COMPLETE_LOCAL_NAME, /* AD data type (Complete local name) */
-        'N',  /* AD data payload (Name of device) */
-        'o',
-        'r',
-        'd',
-        'i',
-        'c',
-        ' ',
-        'S',
-        'e',
-        'm',
-        'i',
-        ' ',
-        'M',
-        'e',
-        's',
-        'h'
-    };
-
-    /* Allocate packet */
-    adv_packet_t * p_packet = advertiser_packet_alloc(&m_advertiser, sizeof(adv_data));
-    if (p_packet)
-    {
-        /* Construct packet contents */
-        memcpy(p_packet->packet.payload, adv_data, sizeof(adv_data));
-        /* Repeat forever */
-        p_packet->config.repeats = ADVERTISER_REPEAT_INFINITE;
-
-        advertiser_packet_send(&m_advertiser, p_packet);
-    }
-
-}
 
 static void node_reset(void)
 {
     __LOG(LOG_SRC_APP, LOG_LEVEL_INFO, "----- Node reset  -----\n");
-    hal_led_blink_ms(LEDS_MASK, LED_BLINK_INTERVAL_MS, LED_BLINK_CNT_RESET);
+    
     /* This function may return if there are ongoing flash operations. */
     mesh_stack_device_reset();
 }
@@ -163,15 +119,12 @@ static void config_server_evt_cb(const config_server_evt_t * p_evt)
 
 static void device_identification_start_cb(uint8_t attention_duration_s)
 {
-    hal_led_mask_set(LEDS_MASK, false);
-    hal_led_blink_ms(BSP_LED_2_MASK  | BSP_LED_3_MASK,
-                     LED_BLINK_ATTENTION_INTERVAL_MS,
-                     LED_BLINK_ATTENTION_COUNT(attention_duration_s));
+    
 }
 
 static void provisioning_aborted_cb(void)
 {
-    hal_led_blink_stop();
+    
 }
 
 static void unicast_address_print(void)
@@ -185,10 +138,7 @@ static void provisioning_complete_cb(void)
 {
     __LOG(LOG_SRC_APP, LOG_LEVEL_INFO, "Successfully provisioned\n");
 
-    unicast_address_print();
-    hal_led_blink_stop();
-    hal_led_mask_set(LEDS_MASK, LED_MASK_STATE_OFF);
-    hal_led_blink_ms(LEDS_MASK, LED_BLINK_INTERVAL_MS, LED_BLINK_CNT_PROV);
+    unicast_address_print();    
 }
 
 static void mesh_init(void)
@@ -215,23 +165,54 @@ static void mesh_init(void)
 
     /* Start listening for incoming packets */
     nrf_mesh_rx_cb_set(rx_cb);
+}
+
+
+static void gpiote_config_pin(uint32_t channel, uint32_t pin)
+{
+    NRF_GPIOTE->CONFIG[channel] = ((pin << GPIOTE_CONFIG_PSEL_Pos) & GPIOTE_CONFIG_PSEL_Msk)
+                                | ((GPIOTE_CONFIG_OUTINIT_Low << GPIOTE_CONFIG_OUTINIT_Pos) & GPIOTE_CONFIG_OUTINIT_Msk)
+                                | ((GPIOTE_CONFIG_POLARITY_Toggle << GPIOTE_CONFIG_POLARITY_Pos) & GPIOTE_CONFIG_POLARITY_Msk)
+                                | ((GPIOTE_CONFIG_MODE_Task << GPIOTE_CONFIG_MODE_Pos) & GPIOTE_CONFIG_MODE_Msk);
+}
 
-    /* Initialize the advertiser */
-    adv_init();
+
+static void debug_ppi_init(void)
+{
+    /* Configure DEBUG_PIN6 to be set high when radio active */
+    gpiote_config_pin(0u, DEBUG_PIN6);
+    NRF_PPI->CH[0u].EEP = (uint32_t)&NRF_RADIO->EVENTS_READY;
+    NRF_PPI->CH[0u].TEP = (uint32_t)&NRF_GPIOTE->TASKS_SET[0u];
+    
+    /* Configure DEBUG_PIN6 to be set low when radio disabled */
+    NRF_PPI->CH[1u].EEP = (uint32_t)&NRF_RADIO->EVENTS_DISABLED;
+    NRF_PPI->CH[1u].TEP = (uint32_t)&NRF_GPIOTE->TASKS_CLR[0u];
+
+    /* Configure DEBUG_PIN7 to be toggled when TIMER0 COMPARE[TS_TIMER_INDEX_TS_END] event fires */
+    gpiote_config_pin(1u, DEBUG_PIN7);
+    NRF_PPI->CH[2u].EEP = (uint32_t)&NRF_TIMER0->EVENTS_COMPARE[TS_TIMER_INDEX_TS_END];
+    NRF_PPI->CH[2u].TEP = (uint32_t)&NRF_GPIOTE->TASKS_OUT[1u];
+
+    NRF_PPI->CHENSET = (1u << 0u) | (1u << 1u) | (1u << 2u);
 }
 
 static void initialize(void)
 {
+    DEBUG_PINS_INIT();
+
+    debug_ppi_init();
+
 #if defined(NRF51) && defined(NRF_MESH_STACK_DEPTH)
     stack_depth_paint_stack();
 #endif
 
     ERROR_CHECK(app_timer_init());
-    hal_leds_init();
+    
 
     __LOG_INIT(LOG_SRC_APP, LOG_LEVEL_INFO, log_callback_rtt);
     __LOG(LOG_SRC_APP, LOG_LEVEL_INFO, "----- Bluetooth Mesh Beacon Example -----\n");
 
+
     ble_stack_init();
 
     mesh_init();
@@ -243,36 +224,33 @@ static void start(void)
 {
     if (!m_device_provisioned)
     {
-        static const uint8_t static_auth_data[NRF_MESH_KEY_SIZE] = STATIC_AUTH_DATA;
-        mesh_provisionee_start_params_t prov_start_params =
-        {
-            .p_static_data    = static_auth_data,
-            .prov_complete_cb = provisioning_complete_cb,
-            .prov_device_identification_start_cb = device_identification_start_cb,
-            .prov_device_identification_stop_cb = NULL,
-            .prov_abort_cb = provisioning_aborted_cb,
-            .p_device_uri = EX_URI_BEACON
-        };
-        ERROR_CHECK(mesh_provisionee_prov_start(&prov_start_params));
+        //static const uint8_t static_auth_data[NRF_MESH_KEY_SIZE] = STATIC_AUTH_DATA;
+        //mesh_provisionee_start_params_t prov_start_params =
+        //{
+        //    .p_static_data    = static_auth_data,
+        //    .prov_complete_cb = provisioning_complete_cb,
+        //    .prov_device_identification_start_cb = device_identification_start_cb,
+        //    .prov_device_identification_stop_cb = NULL,
+        //    .prov_abort_cb = provisioning_aborted_cb,
+        //    .p_device_uri = EX_URI_BEACON
+        //};
+        //ERROR_CHECK(mesh_provisionee_prov_start(&prov_start_params));
     }
     else
     {
-        unicast_address_print();
+        //unicast_address_print();
     }
 
     /* Start advertising own beacon */
     /* Note: If application wants to start beacons at later time, adv_start() API must be called
      * from the same IRQ priority context same as that of the Mesh Stack. */
-    adv_start();
+    //adv_start();
 
     mesh_app_uuid_print(nrf_mesh_configure_device_uuid_get());
 
     ERROR_CHECK(mesh_stack_start());
 
     __LOG(LOG_SRC_APP, LOG_LEVEL_INFO, "Bluetooth Mesh Beacon example started!\n");
-
-    hal_led_mask_set(LEDS_MASK, LED_MASK_STATE_OFF);
-    hal_led_blink_ms(LEDS_MASK, LED_BLINK_INTERVAL_MS, LED_BLINK_CNT_START);
 }
 
 int main(void)
diff --git a/examples/common/include/nrf_mesh_config_examples.h b/examples/common/include/nrf_mesh_config_examples.h
index 0239d0e..deb8e36 100644
--- a/examples/common/include/nrf_mesh_config_examples.h
+++ b/examples/common/include/nrf_mesh_config_examples.h
@@ -68,7 +68,7 @@
 
 /** Enable support for LEDs. */
 #ifndef SIMPLE_HAL_LEDS_ENABLED
-#define SIMPLE_HAL_LEDS_ENABLED 1
+#define SIMPLE_HAL_LEDS_ENABLED 0
 #endif
 
 /** @} end of SIMPLE_HAL_CONFIG */
diff --git a/examples/common/include/simple_hal.h b/examples/common/include/simple_hal.h
index 382fbe1..5600f51 100644
--- a/examples/common/include/simple_hal.h
+++ b/examples/common/include/simple_hal.h
@@ -62,7 +62,7 @@
 
 
 /** Boards with user buttons */
-#define BUTTON_BOARD (defined(BOARD_PCA10040) || defined(BOARD_PCA10028) || defined(BOARD_PCA10056) || defined(BOARD_PCA10100)) //lint -e491 // Suppress "non-standard use of 'defined' preprocessor operator"
+#define BUTTON_BOARD 0
 
 /**
  * Button event handler callback type.
diff --git a/examples/common/src/app_error_weak.c b/examples/common/src/app_error_weak.c
index c7ca370..66d2677 100644
--- a/examples/common/src/app_error_weak.c
+++ b/examples/common/src/app_error_weak.c
@@ -40,6 +40,7 @@
 #include "log.h"
 #include "mesh_app_utils.h"
 #include "boards.h"
+#include "debug_pins.h"
 
 
 /* Copied from nrf_sdm.h (nRF5 SDK 14.2): */
@@ -64,8 +65,8 @@
 static inline void sleep_forever(void)
 {
     /* Turn on all LEDs on board */
-    NRF_GPIO->DIRSET = LEDS_MASK;
-    NRF_GPIO->OUTCLR = LEDS_MASK;
+    //NRF_GPIO->DIRSET = LEDS_MASK;
+    //NRF_GPIO->OUTCLR = LEDS_MASK;
 
     /*lint -save -e438 -e550 Unsused variable irqs_masked */
     uint32_t irqs_masked __attribute__((unused));
@@ -90,6 +91,8 @@ __WEAK void app_error_fault_handler(uint32_t pc, uint16_t id, const uint8_t * p_
 __WEAK void app_error_fault_handler(uint32_t id, uint32_t pc, uint32_t info)
 {
 #endif
+    
+    DEBUG_PIN_ON(DEBUG_PIN5);
     switch (id)
     {
         case NRF_FAULT_ID_SD_ASSERT:
@@ -123,5 +126,6 @@ __WEAK void app_error_fault_handler(uint32_t id, uint32_t pc, uint32_t info)
             __LOG(LOG_SRC_APP, LOG_LEVEL_ERROR, "UNKNOWN FAULT at 0x%08X\n", pc);
             break;
     }
+    DEBUG_PIN_OFF(DEBUG_PIN5);
     sleep_forever();
 }
diff --git a/mesh/bearer/src/bearer_handler.c b/mesh/bearer/src/bearer_handler.c
index b4163dd..8d12897 100644
--- a/mesh/bearer/src/bearer_handler.c
+++ b/mesh/bearer/src/bearer_handler.c
@@ -257,6 +257,7 @@ static void notify_stop(void)
 
 void BEARER_ACTION_TIMER_IRQHandler(void)
 {
+    DEBUG_PIN_ON(DEBUG_PIN4);
     if (mp_action != NULL)
     {
         NRF_MESH_ASSERT(mp_action->timer_irq_handler != NULL);
@@ -275,6 +276,7 @@ void BEARER_ACTION_TIMER_IRQHandler(void)
         NRF_MESH_ASSERT(m_scanner_is_active);
         scanner_timer_irq_handler();
     }
+    DEBUG_PIN_OFF(DEBUG_PIN4);
 }
 
 /*****************************************************************************
diff --git a/mesh/core/include/debug_pins.h b/mesh/core/include/debug_pins.h
index 5efc7d5..d2b7926 100644
--- a/mesh/core/include/debug_pins.h
+++ b/mesh/core/include/debug_pins.h
@@ -53,14 +53,14 @@
 #define DEBUG_PIN6 18
 #define DEBUG_PIN7 19
 #elif defined(NRF52_SERIES) || defined(HOST)
-#define DEBUG_PIN0 22
-#define DEBUG_PIN1 23
-#define DEBUG_PIN2 24
-#define DEBUG_PIN3 25
-#define DEBUG_PIN4 26
-#define DEBUG_PIN5 27
-#define DEBUG_PIN6 28
-#define DEBUG_PIN7 29
+#define DEBUG_PIN0 0u
+#define DEBUG_PIN1 1u
+#define DEBUG_PIN2 9u
+#define DEBUG_PIN3 10u
+#define DEBUG_PIN4 6u
+#define DEBUG_PIN5 8u
+#define DEBUG_PIN6 31u
+#define DEBUG_PIN7 30u
 #endif
 
 #define DEBUG_PIN_UINT_BIT_SET                  DEBUG_PIN6
@@ -172,15 +172,15 @@
 
 #endif //DEBUG_PINS_ENABLED
 
-DEBUG_PIN_MODULE(TIMESLOT, false)
-#define DEBUG_PIN_TS_SIGNAL_CALLBACK         DEBUG_PIN0
-#define DEBUG_PIN_TS_IN_TIMESLOT             DEBUG_PIN1
-#define DEBUG_PIN_TS_EXTEND_HANDLER          DEBUG_PIN2
-#define DEBUG_PIN_TS_TIMER_HANDLER           DEBUG_PIN3
-#define DEBUG_PIN_TS_SD_EVT_HANDLER          DEBUG_PIN4
-#define DEBUG_PIN_TS_END_TIMER_HANDLER       DEBUG_PIN5
-#define DEBUG_PIN_TS_HIGH_PRIORITY           DEBUG_PIN6
-#define DEBUG_PIN_TS_EXTEND_SUCCEEDED        DEBUG_PIN7
+DEBUG_PIN_MODULE(TIMESLOT, true)
+#define DEBUG_PIN_TS_SIGNAL_CALLBACK         DEBUG_PIN1
+#define DEBUG_PIN_TS_IN_TIMESLOT             DEBUG_PIN0
+//#define DEBUG_PIN_TS_EXTEND_HANDLER          DEBUG_PIN2
+#define DEBUG_PIN_TS_TIMER_HANDLER           DEBUG_PIN2
+#define DEBUG_PIN_TS_SD_EVT_HANDLER          DEBUG_PIN3
+//#define DEBUG_PIN_TS_END_TIMER_HANDLER       DEBUG_PIN5
+//#define DEBUG_PIN_TS_HIGH_PRIORITY           DEBUG_PIN6
+//#define DEBUG_PIN_TS_EXTEND_SUCCEEDED        DEBUG_PIN7
 
 DEBUG_PIN_MODULE(BEARER_HANDLER, false)
 #define DEBUG_PIN_BEARER_HANDLER_ACTION         DEBUG_PIN0
diff --git a/mesh/core/src/timeslot.c b/mesh/core/src/timeslot.c
index 3490957..79b986b 100644
--- a/mesh/core/src/timeslot.c
+++ b/mesh/core/src/timeslot.c
@@ -206,7 +206,7 @@ static void on_ts_end(timeslot_t* p_timeslot)
 
     m_state_lock = false;
     DEBUG_PIN_TIMESLOT_OFF(DEBUG_PIN_TS_IN_TIMESLOT);
-    DEBUG_PIN_TIMESLOT_OFF(DEBUG_PIN_TS_HIGH_PRIORITY);
+    //DEBUG_PIN_TIMESLOT_OFF(DEBUG_PIN_TS_HIGH_PRIORITY);
 }
 
 static void handle_forced_command(timeslot_t* p_timeslot)
@@ -267,7 +267,7 @@ static void handle_signal_start(timeslot_t* p_timeslot)
     }
     else
     {
-        DEBUG_PIN_TIMESLOT_ON(DEBUG_PIN_TS_HIGH_PRIORITY);
+        //DEBUG_PIN_TIMESLOT_ON(DEBUG_PIN_TS_HIGH_PRIORITY);
         on_ts_begin(p_timeslot);
     }
 
@@ -278,13 +278,13 @@ static void handle_signal_start(timeslot_t* p_timeslot)
 
 static void handle_extend_end(timeslot_t* p_timeslot, bool success)
 {
-    DEBUG_PIN_TIMESLOT_ON(DEBUG_PIN_TS_EXTEND_HANDLER);
+    //DEBUG_PIN_TIMESLOT_ON(DEBUG_PIN_TS_EXTEND_HANDLER);
     if (success)
     {
-        DEBUG_PIN_TIMESLOT_ON(DEBUG_PIN_TS_EXTEND_SUCCEEDED);
+        //DEBUG_PIN_TIMESLOT_ON(DEBUG_PIN_TS_EXTEND_SUCCEEDED);
         p_timeslot->successful_extensions++;
         p_timeslot->length_us += p_timeslot->signal_ret_param.params.extend.length_us;
-        DEBUG_PIN_TIMESLOT_OFF(DEBUG_PIN_TS_EXTEND_SUCCEEDED);
+        //DEBUG_PIN_TIMESLOT_OFF(DEBUG_PIN_TS_EXTEND_SUCCEEDED);
     }
     p_timeslot->extend_count++;
 
@@ -338,7 +338,7 @@ static void handle_extend_end(timeslot_t* p_timeslot, bool success)
            start normal timeslot operation instead. */
         on_ts_begin(p_timeslot);
     }
-    DEBUG_PIN_TIMESLOT_OFF(DEBUG_PIN_TS_EXTEND_HANDLER);
+    //DEBUG_PIN_TIMESLOT_OFF(DEBUG_PIN_TS_EXTEND_HANDLER);
 }
 
 /*****************************************************************************
@@ -353,7 +353,7 @@ void __attribute__((weak)) timeslot_state_listener(bool timeslot_active) {}
 /** Timeslot end callback. */
 static void end_timer_handler(ts_timestamp_t timestamp)
 {
-    DEBUG_PIN_TIMESLOT_ON(DEBUG_PIN_TS_END_TIMER_HANDLER);
+    //DEBUG_PIN_TIMESLOT_ON(DEBUG_PIN_TS_END_TIMER_HANDLER);
     m_current_timeslot.signal_ret_param.callback_action = NRF_RADIO_SIGNAL_CALLBACK_ACTION_REQUEST_AND_END;
     m_current_timeslot.signal_ret_param.params.request.p_next = &m_radio_request_earliest;
     /* Attempt the long timeslot first. If this creates a BLOCKED event, we'll
@@ -366,7 +366,7 @@ static void end_timer_handler(ts_timestamp_t timestamp)
     {
         m_radio_request_earliest.params.earliest.length_us = TIMESLOT_BASE_LENGTH_SHORT_US;
     }
-    DEBUG_PIN_TIMESLOT_OFF(DEBUG_PIN_TS_END_TIMER_HANDLER);
+    //DEBUG_PIN_TIMESLOT_OFF(DEBUG_PIN_TS_END_TIMER_HANDLER);
 }
 
 /**
@@ -463,9 +463,9 @@ static nrf_radio_signal_callback_return_param_t* radio_signal_callback(uint8_t s
                 DEBUG_PIN_TIMESLOT_ON(DEBUG_PIN_TS_TIMER_HANDLER);
 
                 ts_timer_event_handler();
-                DEBUG_PIN_TIMESLOT_ON(DEBUG_PIN_TS_SD_EVT_HANDLER);
+                //DEBUG_PIN_TIMESLOT_ON(DEBUG_PIN_TS_SD_EVT_HANDLER);
                 bearer_handler_timer_irq_handler();
-                DEBUG_PIN_TIMESLOT_OFF(DEBUG_PIN_TS_SD_EVT_HANDLER);
+                //DEBUG_PIN_TIMESLOT_OFF(DEBUG_PIN_TS_SD_EVT_HANDLER);
 
                 DEBUG_PIN_TIMESLOT_OFF(DEBUG_PIN_TS_TIMER_HANDLER);
                 break;